#include<iostream>
using namespace std;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n,q,l,r;
    cin>>n;
    if(n==1){
        int a,q;
        cin>>a>>q;
        for(int i=0;i<q;i++)
            cin>>a>>a;
        for(int i=0;i<q;i++)
            cout<<"DA\n";
        return 0;
    }
    int a[n],d[n],p[n-2];
    d[0]=0;
    p[0]=0;
    cin>>a[0];
    for(int i=1;i<n;i++){
        cin>>a[i];
        d[i]=d[i-1]+(a[i]<a[i-1]);
    }
    for(int i=1;i<n-2;i++)
        p[i]=p[i-1]+(a[i-1]>a[i+1]&&a[i]>a[i+2]);
    cin>>q;
    bool c[q];
    for(int i=0;i<q;i++){
        cin>>l>>r;
        c[i]=d[r-1]-d[l-1]<2&&!(p[r-2]-p[min(l-1,r-2)]);
    }
    for(int i=0;i<q;i++)
        cout<<(c[i]?"DA\n":"NE\n");
    return 0;}